
/**
 * 
 * This code uses the hardware-adc of gpsStix-board
 * for GumStiX.
 * We can access ADC0,1,2 via
 * /sys/class/ucb1x00/ucb1x00/vcharger
 * /sys/class/ucb1x00/ucb1x00/vbatt 
 * /sys/class/ucb1x00/ucb1x00/batt_temp 
 * (for adc3 we need to add a line to ucb1x00-assabet)
 */


#include "adc.h"
#include <stdio.h>

static struct adc_buf* buffers[NB_ADC];

void adc_buf_channel(uint8_t adc_channel __attribute__ ((unused)), 
		     struct adc_buf* s __attribute__ ((unused)), 
		     uint8_t av_nb_sample __attribute__ ((unused))) {
  printf("adc_buf_channel() channel=%i #samples=%i\n", adc_channel, av_nb_sample);
  buffers[adc_channel] = s;
  s->av_nb_sample = av_nb_sample;
}

/**
 * Read the next value for adc-channel "adc_input"
 * from the file "filename".
 * Usually this will be a special file in /sys
 * or /proc that exposes an ADC-channel
 */
void linux_read_adc(uint8_t adc_input, char *filename) {
  struct adc_buf* buf = buffers[adc_input];
  uint16_t adc_value = 0; //TODO: actually read the value

  if (buf) {
    uint8_t new_head = buf->head + 1;
    if (new_head >= buf->av_nb_sample)
       new_head = 0;
    buf->sum -= buf->values[new_head]; // update the sum
    buf->values[new_head] = adc_value; // update circular buffer of the last n values
    buf->sum += adc_value;             // update the sum
    buf->head = new_head;              // update the index into the buffer
  }
}

/**
 * This function is periodically called from linux/sys_time_periodic.c .
 */
void linux_adc_periodic() {
  printf("linux_adc_periodic()\n");

  if (buffers[0]) 
    linux_read_adc(0, "/sys/class/ucb1x00/ucb1x00/vcharger");
  if (buffers[1]) 
    linux_read_adc(1, "/sys/class/ucb1x00/ucb1x00/vbatt");
  if (buffers[2]) 
    linux_read_adc(2, "/sys/class/ucb1x00/ucb1x00/batt_temp");

  int adc = 0;
  for (adc = 0; adc < NB_ADC; adc++) {
    if ()
  }
}


